import { RuleListInput } from "./RuleListInput";
import { useEffect, useState } from "react";
import { MdOutlineSave } from "react-icons/md";
//import RuleListInput from "./RuleListInput";

const GrammarAdder = ({ save, fileAdd }) => {
  function emptyRule() {
    this.leftSymbol = null;
    this.rightSide = null;
    this.root = false;
  }
  const removeRule = () => {
    setRules(rules.filter((val, ind) => ind != rules.length - 1));
  };

  const addRule = () => {
    if (rules == null) {
      setRules([new emptyRule()]);
      return;
    }

    setRules([...rules, new emptyRule()]);
  };
  const [uri, setUri] = useState("");
  const [rules, setRules] = useState([]);
  const [root, setRoot] = useState(-1);
  const [file, setFile] = useState();
  const [fileInput, setFileInput] = useState(false);
  const [text, setText] = useState("");
  var reader = new FileReader();

  const handleTextSubmit = (e) => {
    e.preventDefault();
    if (!uri) {
      return;
    }
    for (let index = 0; index < rules.length; index++) {
      const rule = rules[index];
      if (rule.leftSymbol == null || rule.rightSide === null) {
        return;
      }
    }
    if (root == -1 || root >= rules.length) {
      save(uri, rules, null);
    } else {
      rules[root].root = true;
      save(uri, rules, rules[root]);
    }

    setUri("");
    setRoot(-1);
    setRules([]);
  };
  useEffect(() => {
    getText(file);
  }, [file]);

  function getEnding(file) {
    var splited = file.name.split(".");
    return splited[splited.length - 1];
  }

  const handleFileSubmit = () => {
    if (file == null) {
      return;
    }
    var ending = getEnding(file);
    var xml = false;
    switch (ending) {
      case "xml":
        xml = true;
        break;
      case "jsgf":
        xml = false;
        break;
      default:
        alert("unknown file type");
        return;
    }
    fileAdd(text, xml);
  };
  const changeInput = () => {
    setFileInput(!fileInput);
  };
  const changeFileInput = async (e) => {
    setFile(e.target.files[0]);
  };
  const getText = async (fil) => {
    if (fil != null) {
      var ending = getEnding(fil);
      if (!(ending == "jsgf" || ending == "xml")) {
        setText("invalid file type");
        return;
      }
      var textPro = await fil.text();
      setText(textPro);
      return;
    }
    setText("");
  };

  return (
    <>
      <button onClick={changeInput}>
        {" "}
        {fileInput ? "TEXT INPUT " : "FILE INPUT"}
      </button>
      {fileInput ? (
        <form onSubmit={handleTextSubmit}>
          <input type="file" onChange={changeFileInput} />
          <MdOutlineSave onClick={handleFileSubmit} />
          <br></br>
          <textarea
            onChange={(e) => setText(e.target.value)}
            className="transparent"
            rows="4"
            cols="50"
            value={text}
          />
        </form>
      ) : (
        <>
          <form onSubmit={handleTextSubmit}>
            <input
              className="transparent"
              onChange={(e) => {
                setUri(e.target.value);
              }}
              type="text"
              placeholder="Set grammar uri"
            />
            <MdOutlineSave onClick={handleTextSubmit} />
            {rules.length > 0 ? (
              <RuleListInput
                rules={rules}
                setRules={setRules}
                setRoot={setRoot}
              />
            ) : (
              <br></br>
            )}
          </form>
          <br></br>
          <button onClick={addRule}> ADD RULE</button>
          {rules.length > 0 && (
            <button onClick={removeRule}> REMOVE RULE</button>
          )}
        </>
      )}
    </>
  );
};

export default GrammarAdder;
