import { useState } from "react";

export function Searches({ setFilteredGrammars, grammars }) {
  const [rootSearch, setRootSearch] = useState(false);
  const [rootQuery, setRootQuery] = useState("");
  const [uriQuery, setUriQuery] = useState("");
  const changeSearch = () => {
    setRootQuery("");
    setUriQuery("");
    setRootSearch(!rootSearch);
    setFilteredGrammars(null);
  };

  const findByRoot = (root) => {
    setRootQuery(root);
    if (root.length == 0) {
      setFilteredGrammars(null);
    }
    setFilteredGrammars(
      grammars.filter(
        (grammar) =>
          grammar.rootRule != null &&
          (grammar.rootRule.leftSymbol.startsWith("<" + root) ||
            grammar.rootRule.leftSymbol.startsWith(root))
      )
    );
  };

  const findByUri = (uri) => {
    setUriQuery(uri);
    if (uri.length == 0) {
      setFilteredGrammars(null);
    }
    setFilteredGrammars(
      grammars.filter((grammar) => grammar.uri.startsWith(uri))
    );
  };
  return (
    <>
      {rootSearch ? (
        <input
          className="transparent"
          placeholder="Search by root rule"
          id="rootSearch"
          value={rootQuery}
          onChange={(e) => findByRoot(e.target.value)}
        />
      ) : (
        <input
          className="transparent"
          placeholder="Search by uri"
          id="uriSearch"
          value={uriQuery}
          onChange={(e) => findByUri(e.target.value)}
        />
      )}

      <button onClick={changeSearch}>
        {" "}
        {rootSearch ? "URI SEARCH" : "ROOT SEARCH"}
      </button>
    </>
  );
}
